<? 
/***************************************
** Title........: HTML parse library - advanced handlers
** Filename.....: adv.inc.php
** Author.......: Elena Alekseeva aka Felenka
** Version......: 1.4
** Notes........:
** Last changed.: 22 Sept 2002
** Last change..: Parsing algorithm is optimized and restructured; comments are provided
***************************************/

require_once(INCLUDE_DIR.'const.inc.php');

// <callback name=makeBool ...>
function makeBool($str = '', $pars = '', $locals = '', $globname = DEFAULT_PARSING_VARNAME){
    if ( !trim($str) ) // if tag inner is empty
        return '';

    if ( !is_array($pars) )
        $pars = AttributesToArray($pars);
        
    // extract extra parameters
    extract($pars);

    $parsevar = &$GLOBALS[ $globname ];

    // if wrong tag initialization, return empty string
    if ( wrongTag('makeBool', &$name, &$var, &$locals, &$save) && (!empty($var)) ) 
        return '';

    // initialize $var
    if ( empty($locals[ $var ]) && (!empty($GLOBALS[$var])) )
	$locals[ $var ] = &$GLOBALS[ $var ];

    // helping initializations
    $isEmpty = isEmpty($locals[ $var ]);
    $isInverted = ( (!empty($type)) && $type == 'invert' );
    $delim = ( empty($delim) ? DEFAULT_PARSE_DELIM : $delim );

    // define what part should be returned
    $false = $true = '';
    @list($true, $false) = explode($delim, $str);
    $return = (((!$isEmpty) && (!$isInverted)) || ($isInverted && $isEmpty) ? $true : $false);

    // apply function (if specified) to selected part
    if ( !empty($func) )
        $res = applyFunc($func, $return, $var, $locals, $pars, $globname);
    
    // save function result to the global variable (if specified)
    if ( !empty($save) ) 
        $GLOBALS[ $save ] = $res;
    return $res;
}

// <callback name=makeRepeat ...>
function makeRepeat($str = '', $pars = '', $locals = '', $globname = DEFAULT_PARSING_VARNAME)
{
    if ( !trim($str) ) // if tag inner is empty
        return '';

    if ( !is_array($pars) )
        $pars = AttributesToArray($pars);
        
    // extract extra parameters
    extract($pars);

    $parsevar = &$GLOBALS[ $globname ];

    // if wrong tag initialization, return empty string
    if ( wrongTag('makeRepeat', &$name, &$var, &$locals, &$save) ) 
        return '';

    // initialize $var
    if ( !empty($locals[ $var ]) )
        $var = &$locals[ $var ];
    else if ( !empty($GLOBALS[ $var ]) )
        $var = &$GLOBALS[ $var ];

    // convert $var to array        
    toArray($var, false);
    
    // get $var size
    $size = sizeof($var);

    // if $var is empty, returns empty string
    if (!$size) {
        if ( !empty($save) ) 
            $GLOBALS[ $save ] = '';
        return '';
    }

    // come through the array    
    $res = '';
    foreach ($var as $idx => $elem){
        if ( !empty($func) ){
            if ( !is_array($elem) )
                $elem = array('elem' => $elem);
            $elem['idx'] = $idx;
            $res .= applyFunc($func, $str, $parsevar, $elem, $pars, $globname);
        }
        else
            $res .= $str;
    }
    
    if ( !empty($ffunc) )
        $res = applyFunc($ffunc, $res, $parsevar, $locals, $pars, $globname);
    
    // save function result to global variable (if specified)
    if ( !empty($save) ) 
        $GLOBALS[ $save ] = $res;

    return $res;
}

// <callback name=fileInclude ...>
function fileInclude($fname = '', $pars = '', $locals = '', $globname = DEFAULT_PARSING_VARNAME)
{
    if ( !is_array($pars) )
        $pars = AttributesToArray($pars);
        
    // extract extra parameters
    extract($pars);

    // if wrong tag initialization, return the $fname untouched
    if ( wrongTag('fileInclude', &$name, &$fname, &$locals, &$save) ) 
        return '';

    $parsevar = &$GLOBALS[ $globname ];

    // apply function $ffunc (if specified) to file name
    if ( !empty($ffunc) )
        $fname = applyFunc($ffunc, $fname, $parsevar, $locals, $pars, $globname);
        
    // if file doesn't exists, returns empty string
    if ( !file_exists($fname) )
        return '';
        
    // get the file content
    $file = join( '', file($fname) );
    
    // apply function $func (if specified) to file content
    if ( !empty($func) )
        $file = applyFunc($func, $file, $parsevar, $locals, $pars, $globname);

    // save function result to global variable (if specified)
    if ( !empty($save) )
        $GLOBALS[ $save ] = $file;
        
    return $file;
}
?>