<? 
/***************************************
** Title........: HTML parse library - miscellanious functions
** Filename.....: misc.inc.php
** Author.......: Elena Alekseeva aka Felenka
** Version......: 1.4
** Notes........:
** Last changed.: 22 Sept 2002
** Last change..: New functinos and comments are provided; older functions are dropped; 
***************************************/

// sets given value to the given indice of array
function setArrVal(&$arr, $idx, $val){ $arr[$idx] = $val;  }

// make valid case insensitive regex based on $name ( analog to 'sql_regcase' PHP-function )
function makeStrCaseI($str = ''){
    return ( empty($str) 
            ? '' 
            : preg_replace('/([A-Za-z])/e', 
                     ' "[".strtolower("\\1").strtoupper("\\1")."]" ', 
                     $str) );
}

// convert variable of any type to array
function toArray(&$par, $strict = true){
    if ( is_array($par) ) 
        return;

    if ( is_object($par) ){
        $par = get_object_vars($par);
        return;
    }
        
    $par = ( $strict ? array() : array($par) );
    return;
}

// convert string "par1=val1 par2=val2 ... " to array('par1' => 'val1', 'par2' => 'val2' ...)
function AttributesToArray($str){
    $res = array();
    preg_replace(    '/([^= ]+)(\=){1}([^ ]+)/se', 
            'setArrVal($res, \'\\1\', \'\\3\')', 
            $str);
    return $res;
}

/* 
apply function $funcname to $str
if function is basic handler, than $locals and $globname are inherited
if function is advanced handler, than $pars, $locals and $globname are inherited
if function is neither basic no advanced handler, it's just applied to $str
if function doesn't exist, $str is untouched

NOTE 1:    to increase the speed, $funcname is NOT checked for emptiness
    do it before function call or suppress the errors
*/
function applyFunc($funcname, &$str, &$var, &$locals, $pars = '', $globname = DEFAULT_PARSING_VARNAME){
    if ( !function_exists($funcname) )
        return $str;
        
    $parsevar = &$GLOBALS[$globname];
    return ( in_array($funcname, $parsevar->basic)
            ? $funcname($str, $locals, $globname)
            : ( in_array($funcname, $parsevar->stand) 
                ? $funcname($str, $pars, $locals, $globname) 
                : $funcname($str) 
               ) 
        );
}

function isEmpty($var){
    if ( empty($var) ) 
        return true;
    
    if ( is_array($var) )
        return ( sizeof($var) == 0 );
    
    if ( is_object($var) )
        return ( sizeof(get_object_vars($var)) == 0 );
    
    return false;
}

function wrongTag($tag = '', $name = '', $var = '', $locals = '', $save = ''){
    $res = ( empty($tag) || empty($name) || $name != $tag || empty($var) );
    
    if ( $tag == 'makeRepeat')
    	$res |= ( empty($locals[$var]) && empty($GLOBALS[$var]) );

    if ( $res && (!empty($save)) ) 
        $GLOBALS[ $save ] = '';
        
    return $res;
}
?>